package org.openxma.dsl.reference.dao.impl;

import org.openxma.dsl.platform.dao.*;
import org.openxma.dsl.platform.dao.impl.*;
import org.openxma.dsl.platform.service.Mapper;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Expression;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jdbc.support.incrementer.DataFieldMaxValueIncrementer;
import org.springframework.stereotype.Repository;
import org.springframework.util.Assert;
import org.openxma.dsl.reference.dao.AddressDao;
import org.openxma.dsl.reference.model.Address;
import org.openxma.dsl.reference.model.impl.AddressImpl;
/**
 * @see AddressDao
 */
@SuppressWarnings("unused")
public abstract class AddressDaoGenImpl extends GenericDaoHibernateImpl<Address,String> implements AddressDao {

    public AddressDaoGenImpl() {
        super(AddressImpl.class);
    }
    
    /**
     * @param context the context for the object creation
     * @return a transient instance of entity <code>Address</code> with an already assigned identifier.
     */
    public Address createEntity(Object context) {
        return create();
    }

    public Address create()
    {
        Address address = createEntityInstance();
        address.setOid(dataFieldMaxValueIncrementer.nextStringValue());
        return address;
    }
    
    protected Mapper getNamedQueryMapper(String queryName) {
		return new AddressDaoQueryMapper();
	}
	
	protected class AddressDaoQueryMapper extends NamedQueryMapper {
	
		@SuppressWarnings("unchecked")
		public <E> E mapOne(Object sourceObject, E targetObject, Object context) {
			return super.mapOne(sourceObject, targetObject);
		}
	}
}
