package org.openxma.dsl.reference.ui.layouting.client;

import java.util.Locale;
import java.util.ResourceBundle;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import at.spardat.xma.page.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.simple.*;
import at.spardat.enterprise.fmt.*;

/**
 * This class implements the generic client part of SiblingAttachment.
 * It implements the widgets and models of the page.
 *
 */
public abstract class SiblingAttachmentGen extends org.openxma.dsl.platform.xma.client.DslNotebookPage {
    private Locale genPageLocale = null;
    private ResourceBundle genPageMessages = null;
    Composite siblingAttachment_composite_0_0W;
    Text t1aW;
    ISimpleWMClient t1a;
    Text t1bW;
    ISimpleWMClient t1b;
    Text t1cW;
    ISimpleWMClient t1c;
    Text t1eW;
    ISimpleWMClient t1e;
    Text t1fW;
    ISimpleWMClient t1f;
    Text t1gW;
    ISimpleWMClient t1g;
    Text t1hW;
    ISimpleWMClient t1h;
    WModel[] widgetModels;
    Control[] widgets;

    /**
     * Constructs the SiblingAttachmentGen.
     * @param notebook the Notebook this page belongs to.
     */
    public SiblingAttachmentGen(Notebook notebook) {
        super(notebook,false);
        createModels();
    }

    /*
     * returns the Locale used for this page
    */
    final protected Locale getGenPageLocale() {
        if (genPageLocale == null) {
            genPageLocale = getComponent().getContext().getLocale();
        }
        return genPageLocale;
    }

    /*
     * returns the message resource bundle used for this page
    */
    final protected ResourceBundle getGenPageMessages() {
        if (genPageMessages == null) {
            genPageMessages = ResourceBundle.getBundle("org.openxma.dsl.reference.ui.layouting.client.Layouting",getGenPageLocale());
        }
        return genPageMessages;
    }

    /**
     * Create and initialize the WidgetModels of the page.
     * Subpages which are not lazy are created too.
     */
    public void createModels() {
        IFmt formatter;
        t1a = new SimpleWMClient((short) 0, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1a.setFmt(formatter);
        t1b = new SimpleWMClient((short) 1, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1b.setFmt(formatter);
        t1c = new SimpleWMClient((short) 2, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1c.setFmt(formatter);
        t1e = new SimpleWMClient((short) 3, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1e.setFmt(formatter);
        t1f = new SimpleWMClient((short) 4, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1f.setFmt(formatter);
        t1g = new SimpleWMClient((short) 5, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1g.setFmt(formatter);
        t1h = new SimpleWMClient((short) 6, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        t1h.setFmt(formatter);

        widgetModels = new WModel[] { (WModel) t1a, (WModel) t1b, (WModel) t1c, (WModel) t1e, (WModel) t1f, (WModel) t1g, (WModel) t1h };
        getComponent().registerPageModel(this);
    }

    /**
     * Indicate if the WidgetModels are already created.
     * @return true if the WidgetModels exist.
     */
    public boolean hasModels() {
        return widgetModels != null;
    }

    /**
     * Remove all WidgetModels of the page.
     */
    public void removeWidgetModels() {
        t1a = null;
        t1b = null;
        t1c = null;
        t1e = null;
        t1f = null;
        t1g = null;
        t1h = null;
        widgetModels = null;
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return Layouting.SiblingAttachmentClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public Layouting getTypedComponent() {
        return (Layouting) getComponent();
    }

    /**
     * Returns an array of all Widgets of this page.
     * @return array of Widgets. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public Control[] getWidgets() {
        return widgets;
    }

    /**
     * Replaces the widget array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWidgets(Control[] widgets) {
        this.widgets=widgets;
    }

    /**
     * Create and initialize all SWT-Widgets of the page.
     * It <br>
     * <ul>
     * <li> instantiates the Widgets </li>
     * <li> sets constant texts (Title, Labels, Tooltips) and Images </li>
     * <li> registers the eventadapter </li>
     * <li> defines the Layout (Attachments, Distances, Sizes) </li>
     * <li> sets the focus </li>
     * <li> defines the Taborder </li>
     * </ul>
     */
    protected void createWidgets() {
        FormData data;
        Control[] tabOrder;
        EventAdapter adapter = new EventAdapter(this);
        final Scaler scaler = Scaler.getInstance(getComposite());

        Composite pageCompositesiblingAttachmentW = getComposite();
        FormLayout layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        pageCompositesiblingAttachmentW.setLayout(layout);

        siblingAttachment_composite_0_0W = new Composite(pageCompositesiblingAttachmentW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        siblingAttachment_composite_0_0W.setLayout(layout);
        siblingAttachment_composite_0_0W.setData("WIDGET_ID","siblingAttachment_composite_0_0W");

        t1aW = new Text(siblingAttachment_composite_0_0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1aW.setData("WIDGET_ID","t1aW");
        t1aW.addFocusListener(adapter);
        t1aW.addModifyListener(adapter);
        t1aW.addVerifyListener(adapter);

        t1bW = new Text(siblingAttachment_composite_0_0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1bW.setData("WIDGET_ID","t1bW");
        t1bW.addFocusListener(adapter);
        t1bW.addModifyListener(adapter);
        t1bW.addVerifyListener(adapter);

        t1cW = new Text(siblingAttachment_composite_0_0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1cW.setData("WIDGET_ID","t1cW");
        t1cW.addFocusListener(adapter);
        t1cW.addModifyListener(adapter);
        t1cW.addVerifyListener(adapter);

        t1eW = new Text(siblingAttachment_composite_0_0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1eW.setData("WIDGET_ID","t1eW");
        t1eW.addFocusListener(adapter);
        t1eW.addModifyListener(adapter);
        t1eW.addVerifyListener(adapter);

        t1fW = new Text(siblingAttachment_composite_0_0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1fW.setData("WIDGET_ID","t1fW");
        t1fW.addFocusListener(adapter);
        t1fW.addModifyListener(adapter);
        t1fW.addVerifyListener(adapter);

        t1gW = new Text(siblingAttachment_composite_0_0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1gW.setData("WIDGET_ID","t1gW");
        t1gW.addFocusListener(adapter);
        t1gW.addModifyListener(adapter);
        t1gW.addVerifyListener(adapter);

        t1hW = new Text(siblingAttachment_composite_0_0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        t1hW.setData("WIDGET_ID","t1hW");
        t1hW.addFocusListener(adapter);
        t1hW.addModifyListener(adapter);
        t1hW.addVerifyListener(adapter);

        widgets = new Control[] { siblingAttachment_composite_0_0W, t1aW, t1bW, t1cW, t1eW, t1fW, t1gW, t1hW };

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        siblingAttachment_composite_0_0W.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        t1aW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(t1aW,scaler.convertXToCurrent(14),SWT.RIGHT);
        data.top = new FormAttachment(t1aW,scaler.convertYToCurrent(3),SWT.BOTTOM);
        t1bW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(t1aW,scaler.convertXToCurrent(14),SWT.RIGHT);
        data.top = new FormAttachment(t1bW,scaler.convertYToCurrent(3),SWT.BOTTOM);
        t1cW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(t1aW,scaler.convertXToCurrent(14),SWT.RIGHT);
        data.top = new FormAttachment(t1cW,scaler.convertYToCurrent(3),SWT.BOTTOM);
        t1eW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(t1aW,scaler.convertXToCurrent(14),SWT.RIGHT);
        data.top = new FormAttachment(t1eW,scaler.convertYToCurrent(3),SWT.BOTTOM);
        t1fW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(t1aW,scaler.convertXToCurrent(14),SWT.RIGHT);
        data.top = new FormAttachment(t1fW,scaler.convertYToCurrent(3),SWT.BOTTOM);
        t1gW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(t1aW,scaler.convertXToCurrent(14),SWT.RIGHT);
        data.top = new FormAttachment(t1gW,scaler.convertYToCurrent(3),SWT.BOTTOM);
        t1hW.setLayoutData(data);


        tabOrder = new Control[1];
        tabOrder[0] = siblingAttachment_composite_0_0W;
        pageCompositesiblingAttachmentW.setTabList(tabOrder);
        tabOrder = new Control[7];
        tabOrder[0] = t1aW;
        tabOrder[1] = t1bW;
        tabOrder[2] = t1cW;
        tabOrder[3] = t1eW;
        tabOrder[4] = t1fW;
        tabOrder[5] = t1gW;
        tabOrder[6] = t1hW;
        siblingAttachment_composite_0_0W.setTabList(tabOrder);
    }

    /**
     * Remove all Widgets of the page after they have been disposed.
     */
    public void removeWidgets() {
        siblingAttachment_composite_0_0W = null;
        t1aW = null;
        t1bW = null;
        t1cW = null;
        t1eW = null;
        t1fW = null;
        t1gW = null;
        t1hW = null;
        widgets = null;
    }


    /**
     * Attaches all WidgetModels of the page to there corresponding Widgets.
     */
    public void attachUIImpl() throws AttachmentExceptionClient {
        t1aW.setData(t1a.getUIDelegate());
        t1a.getUIDelegate().attachUI(t1aW,null);
        t1bW.setData(t1b.getUIDelegate());
        t1b.getUIDelegate().attachUI(t1bW,null);
        t1cW.setData(t1c.getUIDelegate());
        t1c.getUIDelegate().attachUI(t1cW,null);
        t1eW.setData(t1e.getUIDelegate());
        t1e.getUIDelegate().attachUI(t1eW,null);
        t1fW.setData(t1f.getUIDelegate());
        t1f.getUIDelegate().attachUI(t1fW,null);
        t1gW.setData(t1g.getUIDelegate());
        t1g.getUIDelegate().attachUI(t1gW,null);
        t1hW.setData(t1h.getUIDelegate());
        t1h.getUIDelegate().attachUI(t1hW,null);
    }

    /**
     * This method will be called every time the SiblingAttachment becomes visible.
     */
    protected void enter() {
        super.enter();
    }

    /**
     * Calls the clientevent configured for the widget of the event.
     *
     * @param event the SWT-Event that happened.
     * @param type the type of the Event, as defined by the event type constants in class SWT.
     */
    protected void clientEvent(SelectionEvent event,int type) {
    }

    /**
     * Creates the coresponding TabItem
     */
    protected TabItem createTabItem(TabFolder LayoutingPage_tabfolder_0_0_0_0W,int index) {
        TabItem siblingAttachmentW = new TabItem (LayoutingPage_tabfolder_0_0_0_0W, SWT.NULL, index);
        siblingAttachmentW.setText(getGenPageMessages().getString("SiblingAttachment"));
        siblingAttachmentW.setControl(getComposite());
        siblingAttachmentW.setData(this);

        return siblingAttachmentW;
    }
}
