package org.openxma.dsl.reference.ui.layouting.server;

import at.spardat.xma.page.*;
import at.spardat.xma.component.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.simple.*;

/**
 * This class implements the generic server part of AbsoluteAttachment.
 * It implements the models of the page.
 *
 */
public abstract class AbsoluteAttachmentGen extends PageServer {
    ISimpleWM t1a;
    ISimpleWM t1b;
    ISimpleWM t1c;
    ISimpleWM t1d;
    ISimpleWM customer1_firstName;
    ISimpleWM customer1_lastName;
    ISimpleWM t2a;
    ISimpleWM t2b;
    ISimpleWM t2c;
    ISimpleWM t2d;
    ISimpleWM customer2_firstName;
    ISimpleWM customer2_lastName;
    ISimpleWM t3a;
    ISimpleWM t3b;
    ISimpleWM t3c;
    ISimpleWM t3d;
    ISimpleWM customer3_firstName;
    ISimpleWM customer3_lastName;
    WModel[] widgetModels;


    /**
     * Constructs the AbsoluteAttachmentGen.
     * This constructor is called by the runtime. Do not remove!
     *
     * @param component the component this page belongs to
     */
    public AbsoluteAttachmentGen(ComponentServer component) {
        super(component, false);
        createModels();
    }

    /**
     * Create and initialize the WidgetModels of the page.
     */
    public void createModels() {
        t1a = new SimpleWM((short) 0, Types.T_STRING, this);
        t1b = new SimpleWM((short) 1, Types.T_STRING, this);
        t1c = new SimpleWM((short) 2, Types.T_STRING, this);
        t1d = new SimpleWM((short) 3, Types.T_STRING, this);
        customer1_firstName = new SimpleWM((short) 4, Types.T_STRING, this);
        customer1_lastName = new SimpleWM((short) 5, Types.T_STRING, this);
        t2a = new SimpleWM((short) 6, Types.T_STRING, this);
        t2b = new SimpleWM((short) 7, Types.T_STRING, this);
        t2c = new SimpleWM((short) 8, Types.T_STRING, this);
        t2d = new SimpleWM((short) 9, Types.T_STRING, this);
        customer2_firstName = new SimpleWM((short) 10, Types.T_STRING, this);
        customer2_lastName = new SimpleWM((short) 11, Types.T_STRING, this);
        t3a = new SimpleWM((short) 12, Types.T_STRING, this);
        t3b = new SimpleWM((short) 13, Types.T_STRING, this);
        t3c = new SimpleWM((short) 14, Types.T_STRING, this);
        t3d = new SimpleWM((short) 15, Types.T_STRING, this);
        customer3_firstName = new SimpleWM((short) 16, Types.T_STRING, this);
        customer3_lastName = new SimpleWM((short) 17, Types.T_STRING, this);

        widgetModels = new WModel[] { (WModel) t1a, (WModel) t1b, (WModel) t1c, (WModel) t1d, (WModel) customer1_firstName, (WModel) customer1_lastName, (WModel) t2a, (WModel) t2b, (WModel) t2c, (WModel) t2d, (WModel) customer2_firstName, (WModel) customer2_lastName, (WModel) t3a, (WModel) t3b, (WModel) t3c, (WModel) t3d, (WModel) customer3_firstName, (WModel) customer3_lastName };
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return Layouting.AbsoluteAttachmentClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public Layouting getTypedComponent() {
        return (Layouting) getComponent();
    }

    /**
     * Copies values of all attached widget models to attributes of the BusinessData instance variables.
     * Copies them for this page and all contained NotebookPages and statically embedded Pages
     * (embedded via XMAContainer in guidesigner)
     */
    public void modelToInstanceData() {
        atomicWMToBusinessData(getTypedComponent().getCustomer1(), getTypedComponent().getCustomer2(), getTypedComponent().getCustomer3());
    }

    /**
     * Copies attribute values of the BusinessData instance variables into their attached widget models.
     * This includes simple widget models and tables.
     * Copies them for this page and all contained NotebookPages and statically embedded Pages
     * (embedded via XMAContainer in guidesigner)
     */
    public void instanceDataToModel() {
        businessDataToAtomicWM(getTypedComponent().getCustomer1(), getTypedComponent().getCustomer2(), getTypedComponent().getCustomer3());
    }

    /**
     * Copies values of widget models to attributes of the provided BusinessData objects.
     */
    public void atomicWMToBusinessData(org.openxma.dsl.reference.dto.CustomerView customer1, org.openxma.dsl.reference.dto.CustomerView customer2, org.openxma.dsl.reference.dto.CustomerView customer3) {
        customer1.setFirstName(customer1_firstName.toString());
        customer1.setLastName(customer1_lastName.toString());
        customer2.setFirstName(customer2_firstName.toString());
        customer2.setLastName(customer2_lastName.toString());
        customer3.setFirstName(customer3_firstName.toString());
        customer3.setLastName(customer3_lastName.toString());
    }

    /**
     * Copies attribute values of the provided BusinessDatas into widget models.
     */
    public void businessDataToAtomicWM(org.openxma.dsl.reference.dto.CustomerView customer1, org.openxma.dsl.reference.dto.CustomerView customer2, org.openxma.dsl.reference.dto.CustomerView customer3) {
        customer1_firstName.set(customer1.getFirstName());
        customer1_lastName.set(customer1.getLastName());
        customer2_firstName.set(customer2.getFirstName());
        customer2_lastName.set(customer2.getLastName());
        customer3_firstName.set(customer3.getFirstName());
        customer3_lastName.set(customer3.getLastName());
    }

    /**
     * Sets the given subpage. The method automatically chooses the
     * correct member variable to set.
     * @param child the subpage to set.
     */
    public void setChild(PageServer child) {
       // no subpages - nothing to do
    }

    /**
     * Removes the given subpage. The method automatically chooses the
     * correct member variable to clear.
     * @param child the subpage to set.
     */
    public void removeChild(PageServer child) {
       // no subpages - nothing to do
    }

}
