package org.openxma.dsl.reference.xma.customeredit.server;

import at.spardat.xma.component.ComponentServer;
import at.spardat.xma.component.ComponentProperty;
import at.spardat.xma.session.XMASessionServer;

/**
 *  Customer Edit Comop
 *  
 * This class implements the generic server part of CustomerEdit.
 * It provides the mapping between typeIds and classnames
 * of all pages in the component.
 *
 */
abstract public class CustomerEditGen extends org.openxma.dsl.platform.xma.SpringComponentServer {

    /**
     * the mode of the component
     */
    protected String mode = "default";

    /**
     * the id of the selected customer
     */
    protected String selectedCustomerId;

    /**
     * firstname of the selected customer
     */
    protected String selectedCustomerFirstName;

    /**
     * lastname of the selected customer
     */
    protected String selectedCustomerLastName;

    /**
     * uncommentedProperty - property
     */
    protected String uncommentedProperty;

    /** describes all component properties */
    private ComponentProperty[] propDes;

    org.openxma.dsl.reference.dto.CustomerView customer;
    java.util.Collection customers;
    java.util.Collection orders;
    org.openxma.dsl.reference.dto.VODataView vodata;

    /**
     * Initializes the CustomerEditGen. This method is called
     * by the XMA-Runtime.
     *
     * @param session the XMASession, this CustomerEditGen belongs to.
     * @param id the unique id of this CustomerEdit.
     */
    public CustomerEditGen (XMASessionServer session,short id) {
        super (session,false,id);
    }


    /** the unique typeId for the page CustomerSearchForm */
    public static final short CustomerSearchFormClass = 0;
    /** the unique typeId for the page CustomerEditForm */
    public static final short CustomerEditFormClass = 1;
    /** the unique typeId for the page Page1 */
    public static final short Page1Class = 2;
    /** the unique typeId for the page Page2 */
    public static final short Page2Class = 3;

    /**
    * Array of the classnames of all pages in
    * this component. The typeIds are used as indices
    * into this array.
     */
    static final String[] modelClasses = {
        "CustomerSearchForm",
        "CustomerEditForm",
        "Page1",
        "Page2"
    };

    /**
    * Gets the short classname for the given typeId of
    * a page in this component. The short classname does
    * not contain the package.
    *
    * @param typeId the unique typeId
    * @return the short classname
     */
    static public String getShortModelClass(short typeId) {
        return modelClasses[typeId];
    }

    /**
    * Gets the full classname for the given typeId of
    * a page in this component.
    *
    * @param typeId the unique typeId
    * @return the full classname
     */
    public String getModelClass(short typeId) {
        return "org.openxma.dsl.reference.xma.customeredit.server."+modelClasses[typeId];
    }

    /**
     * the mode of the component
     */
    protected String getMode() {
        return mode;
    }

    /**
     * the mode of the component
     */
    public void setMode(String mode) {
        this.mode = mode;
    }

    /**
     * the id of the selected customer
     */
    public String getSelectedCustomerId() {
        return selectedCustomerId;
    }

    /**
     * the id of the selected customer
     */
    protected void setSelectedCustomerId(String selectedCustomerId) {
        this.selectedCustomerId = selectedCustomerId;
    }

    /**
     * firstname of the selected customer
     */
    public String getSelectedCustomerFirstName() {
        return selectedCustomerFirstName;
    }

    /**
     * firstname of the selected customer
     */
    protected void setSelectedCustomerFirstName(String selectedCustomerFirstName) {
        this.selectedCustomerFirstName = selectedCustomerFirstName;
    }

    /**
     * lastname of the selected customer
     */
    public String getSelectedCustomerLastName() {
        return selectedCustomerLastName;
    }

    /**
     * lastname of the selected customer
     */
    protected void setSelectedCustomerLastName(String selectedCustomerLastName) {
        this.selectedCustomerLastName = selectedCustomerLastName;
    }

    /**
     * uncommentedProperty - property
     */
    protected String getUncommentedProperty() {
        return uncommentedProperty;
    }

    /**
     * uncommentedProperty - property
     */
    protected void setUncommentedProperty(String uncommentedProperty) {
        this.uncommentedProperty = uncommentedProperty;
    }

    /**
     * @return descriptors of the properties of this component
     */
    protected ComponentProperty[] getPropDes() {
        if(propDes==null) {
            propDes = new ComponentProperty[5];
            propDes[0]=new ComponentProperty("mode",String.class,this,CustomerEditGen.class);
            propDes[1]=new ComponentProperty("selectedCustomerId",String.class,this,CustomerEditGen.class);
            propDes[2]=new ComponentProperty("selectedCustomerFirstName",String.class,this,CustomerEditGen.class);
            propDes[3]=new ComponentProperty("selectedCustomerLastName",String.class,this,CustomerEditGen.class);
            propDes[4]=new ComponentProperty("uncommentedProperty",String.class,this,CustomerEditGen.class);
        }
        return propDes;
    }

    /**
     * returns the customer
     */
    public org.openxma.dsl.reference.dto.CustomerView getCustomer() {
        return customer;
    }

    /**
     * sets the customer
     */
    public void setCustomer(org.openxma.dsl.reference.dto.CustomerView customer) {
        this.customer = customer;
    }

    /**
     * returns the customers
     */
    public java.util.Collection getCustomers() {
        return customers;
    }

    /**
     * sets the customers
     */
    public void setCustomers(java.util.Collection customers) {
        this.customers = customers;
    }

    /**
     * returns the orders
     */
    public java.util.Collection getOrders() {
        return orders;
    }

    /**
     * sets the orders
     */
    public void setOrders(java.util.Collection orders) {
        this.orders = orders;
    }

    /**
     * returns the vodata
     */
    public org.openxma.dsl.reference.dto.VODataView getVodata() {
        return vodata;
    }

    /**
     * sets the vodata
     */
    public void setVodata(org.openxma.dsl.reference.dto.VODataView vodata) {
        this.vodata = vodata;
    }


}
